<?php
/**
 *
 */
class plgHikamarketVendorUsergroup extends JPlugin {
	/**
	 *
	 * @param string $subject
	 * @param object $config
	 */
	public function __construct(&$subject, $config) {
		parent::__construct($subject, $config);
	}

	/**
	 *
	 */
	public function onAfterVendorCreate(&$vendor) {
		$vendorGroup = (int)$this->params->get('vendor_group', 0);
		if(empty($vendorGroup))
			return;

		$move_user = (int)$this->params->get('move_user', 0);
		$default_group = (int)$this->params->get('default_group', 0);

		if(!$move_user)
			$default_group = 0;

		$userClass = hikamarket::get('shop.class.user');
		$user = $userClass->get($vendor->vendor_admin_id);
		$this->updateGroup($user->user_cms_id, $vendorGroup, $default_group);
	}

	/**
	 *
	 * @param integer $user_id
	 * @param integer $new_group_id
	 * @param integer $remove_group_id
	 */
	private function updateGroup($user_id, $new_group_id, $remove_group_id = 0) {
		$user = clone(JFactory::getUser($user_id));
		if(version_compare(JVERSION,'1.6.0','<')) {
			// When the user is super admin, do not change his group
			//
			if($user->gid != 25) {
				$user->set('gid', $new_group_id);
				$acl = JFactory::getACL();
				$user->set('usertype', $acl->get_group_name($new_group_id));
			}
		} else {
			jimport('joomla.access.access');
			$userGroups = JAccess::getGroupsByUser($user_id, true);
			$userGroups[] = $new_group_id;
			if(!empty($remove_group_id)) {
				$key = array_search($remove_group_id, $userGroups);
				if(is_int($key)) {
					unset($userGroups[$key]);
				}
			}
			$user->set('groups', $userGroups);
		}
		$user->save();
	}
}
